﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;
using System.Drawing;

namespace WinTreeToolTip
{
    class MyCreation:IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        public void AfterCreateChildElements(UIElement parent)
        {
            //throw new NotImplementedException();
            NodeSelectableAreaUIElement node = parent as NodeSelectableAreaUIElement;
            if (node != null && node.HasChildElements)
            {
                string val = "";
                UltraTreeNodeCellUIElement spanCell = null;
                for (int el = 0; el < node.ChildElements.Count; el++ )
                {
                    UltraTreeNodeCellUIElement cell = node.ChildElements[el] as UltraTreeNodeCellUIElement;
                    if (cell == null)
                        continue;
                    if (cell.Cell.Value.ToString() != val)
                    {
                        val = cell.Cell.Value.ToString();
                        spanCell = cell;
                    }
                    else
                    {
                        spanCell.Rect = new Rectangle(spanCell.Rect.Location,
                            new Size(spanCell.Rect.Width + cell.Rect.Width, spanCell.Rect.Height));
                        cell.Rect = new Rectangle(cell.Rect.Location, new Size(0, 0));
                    }

                }
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;//throw new NotImplementedException();
        }

        #endregion
    }
}
